/* ICCCM テキストプロパティ
 *
 * ボタン押しで終了 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "util.h"

/* 文字列から TEXT タイプのプロパティをセット */

static void _set_text_prop(Display *disp,Window win,Atom prop,const char *str)
{
	XTextProperty text;

	if(Xutf8TextListToTextProperty(disp, (char **)&str, 1, XCompoundTextStyle, &text) == Success)
	{
		XSetTextProperty(disp, win, &text, prop);
	
		XFree(text.value);
	}
}

int main(int argc,char **argv)
{
	Display *disp;
	Window win;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	win = create_test_window(disp, ButtonPressMask);

	_set_text_prop(disp, win, XInternAtom(disp, "WM_NAME", False), "テスト(Normal)");

	_set_text_prop(disp, win, XInternAtom(disp, "WM_ICON_NAME", False), "テスト(Icon)");

	//イベント

	XMapWindow(disp, win);

	eventloop_button_quit(disp);

	XCloseDisplay(disp);

	return 0;
}
