/* Withdrawn 状態の切り替え
 *
 * F11 キーを押すと、Normal <-> Withdrawn に切り替える。
 * ボタン押しで終了。 */

#include <string.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include "util.h"

static void _withdrawn(Display *disp,Window win)
{
	XEvent ev;

	XUnmapWindow(disp, win);

	memset(&ev, 0, sizeof(XEvent));

	ev.xunmap.type = UnmapNotify;
	ev.xunmap.event = g_disp.root;
	ev.xunmap.window = win;
	ev.xunmap.from_configure = False;

	XSendEvent(disp, g_disp.root, False,
		SubstructureRedirectMask | SubstructureNotifyMask, &ev);
}

int main(int argc,char **argv)
{
	Display *disp;
	Window win;
	XEvent ev;
	int keycode,fmap;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	win = create_test_window(disp,
		ButtonPressMask | KeyPressMask | KeyReleaseMask);

	//F11 キーをパッシブグラブ

	keycode = XKeysymToKeycode(disp, XK_F11);

	XGrabKey(disp, keycode, AnyModifier, g_disp.root,
		False, GrabModeAsync, GrabModeAsync);

	//イベント

	fmap = 1;

	XMapWindow(disp, win);

	while(1)
	{
		XNextEvent(disp, &ev);

		switch(ev.type)
		{
			case KeyPress:
				if(ev.xkey.keycode == keycode)
				{
					if(fmap)
						_withdrawn(disp, win);
					else
						XMapWindow(disp, win);

					fmap ^= 1;
				}
				break;
			case ButtonPress:
				goto END;
		}
	}

END:
	XCloseDisplay(disp);

	return 0;
}
