/* WM_NORMAL_HITS
 *
 * 引数なし、または "0" を指定すると、ウィンドウサイズの設定。
 * 引数に "1" を指定すると、アスペクト比を 4:3 に固定。
 *
 * ボタン押しで終了。 */

#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "util.h"

int main(int argc,char **argv)
{
	Display *disp;
	Window win;
	XSizeHints *sh;
	int type;

	if(argc < 2)
		type = 0;
	else
		type = atoi(argv[1]);
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	win = create_test_window(disp, ButtonPressMask);

	//WM_NORMAL_HINTS

	sh = XAllocSizeHints();

	switch(type)
	{
		//位置固定, min(50x50), max(500x500), 50 ずつサイズが変化
		case 0:
			XMoveWindow(disp, win, 100, 100);

			sh->flags = PPosition | PMinSize | PMaxSize | PResizeInc;
			sh->min_width = sh->min_height = 50;
			sh->max_width = sh->max_height = 500;
			sh->width_inc = sh->height_inc = 50;
			break;
		//アスペクト比を 4:3 で固定
		default:
			sh->flags = PAspect;
			sh->min_aspect.x = 4, sh->min_aspect.y = 3;
			sh->max_aspect.x = 4, sh->max_aspect.y = 3;
			break;
	}

	XSetWMNormalHints(disp, win, sh);

	XFree(sh);

	//イベント

	XMapWindow(disp, win);

	eventloop_button_quit(disp);

	XCloseDisplay(disp);

	return 0;
}
