/* WM_PROTOCOLS
 * 
 * ボタン押しで終了。 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include "util.h"

const char *g_atom_names[] = {
	"WM_PROTOCOLS",
	"WM_DELETE_WINDOW",
	"WM_TAKE_FOCUS"
};

int main(int argc,char **argv)
{
	Display *disp;
	Window win;
	XEvent ev;
	Atom atom[3],type;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	win = create_test_window(disp, ButtonPressMask | FocusChangeMask);

	//アトム取得

	XInternAtoms(disp, (char **)g_atom_names, 3, False, atom);

	//WM_PROTOCOLS

	XChangeProperty(disp, win, atom[0], XA_ATOM, 32,
		PropModeReplace, (unsigned char *)&atom[1], 2);

	//イベント

	XMapWindow(disp, win);

	while(1)
	{
		XNextEvent(disp, &ev);

		switch(ev.type)
		{
			case ClientMessage:
				if(ev.xclient.message_type == atom[0])
				{
					type = (Atom)ev.xclient.data.l[0];

					if(type == atom[1])
						printf("WM_DELETE_WINDOW\n");
					else if(type == atom[2])
					{
						printf("WM_TAKE_FOCUS: time=%lu\n", ev.xclient.data.l[1]);

						XSetInputFocus(disp, ev.xclient.window, RevertToParent, ev.xclient.data.l[1]);
					}
				}
				break;
			case FocusIn:
				printf("FocusIn\n");
				break;
			case ButtonPress:
				goto END;
		}
	}

END:
	XCloseDisplay(disp);

	return 0;
}
