/* ダイアログウィンドウ
 * 
 * 黒ウィンドウ内でボタンを押すと、ダイアログウィンドウ表示。
 * 装飾の閉じるボタンで、それぞれ閉じる。 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "util.h"

int main(int argc,char **argv)
{
	Display *disp;
	Window win,windlg = None;
	XEvent ev;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	win = create_test_window2(disp, 300, 300, 0, ButtonPressMask);

	//イベント

	XMapWindow(disp, win);

	while(1)
	{
		XNextEvent(disp, &ev);

		if(event_quit(&ev))
		{
			//WM_DELETE_WINDOW

			if(ev.xany.window == win)
				//メインウィンドウなら終了
				break;
			else
			{
				//ダイアログ閉じる
				XDestroyWindow(disp, windlg);
				windlg = None;
				continue;
			}
		}

		switch(ev.type)
		{
			case ButtonPress:
				if(!windlg)
				{
					//ダイアログ作成

					windlg = create_test_window2(disp, 200, 200, rgb_to_pixel(0x0000ff), 0);

					XSetTransientForHint(disp, windlg, win);
					XMapWindow(disp, windlg);
				}
				break;
		}
	}

	XCloseDisplay(disp);

	return 0;
}
