/* _NET_WM_PING
 *
 * 左ボタン押しで、_NET_WM_PING の応答をする/しないを切り替え。
 * それ以外のボタン押しで終了。 */

#include <stdio.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include "util.h"

static void _set_client_machine(Window win)
{
	char m[64],*pstr;
	XTextProperty tp;

	gethostname(m, 64);
	m[63] = 0;

	printf("hostname: %s\n", m);

	pstr = m;

	if(XmbTextListToTextProperty(g_disp.disp,
		&pstr, 1, XStdICCTextStyle, &tp) == Success)
	{
		XSetWMClientMachine(g_disp.disp, win, &tp);

		XFree(tp.value);
	}
}

int main(int argc,char **argv)
{
	Display *disp;
	Window win;
	XEvent ev;
	Atom atom_ping,atoms[2];
	int fsend = 1;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);
	init_locale();

	win = create_test_window2(disp, 200, 200, 0, ButtonPress);

	//プロパティ

	atom_ping = GET_ATOM("_NET_WM_PING");

	atoms[0] = g_disp.atoms[ATOM_WM_DELETE_WINDOW];
	atoms[1] = atom_ping;
	
	set_prop32_array(win, g_disp.atoms[ATOM_WM_PROTOCOLS], XA_ATOM, atoms, 2);

	set_prop32_one(win, GET_ATOM("_NET_WM_PID"), XA_CARDINAL, getpid());

	_set_client_machine(win);

	//イベント

	XMapWindow(disp, win);

	while(1)
	{
		XNextEvent(disp, &ev);

		switch(ev.type)
		{
			case ButtonPress:
				if(ev.xbutton.button == Button1)
				{
					fsend ^= 1;
					printf("* send_ping: %s\n", (fsend)? "yes": "no");
				}
				else
					goto END;
				break;
			case ClientMessage:
				if(ev.xclient.message_type == g_disp.atoms[ATOM_WM_PROTOCOLS])
				{
					if(ev.xclient.data.l[0] == g_disp.atoms[ATOM_WM_DELETE_WINDOW])
						printf("[WM_DELETE_WINDOW]\n");
					else if(ev.xclient.data.l[0] == atom_ping)
					{
						//_NET_WM_PING

						printf("[_NET_WM_PING] timestamp(%ld) window(0x%lx)\n",
							ev.xclient.data.l[1], ev.xclient.data.l[2]);

						if(!fsend) break;

						ev.xclient.window = g_disp.root;

						XSendEvent(disp, g_disp.root, False,
							SubstructureNotifyMask | SubstructureRedirectMask, &ev);
					}
				}
				break;
		}
	}

END:
	XCloseDisplay(disp);

	return 0;
}
