/* _MOTIF_WM_HINTS
 *
 * リサイズ・最小化・最大化ができないウィンドウ。
 *
 * 閉じるボタン or ポインタボタン押しで終了。 */

#include <stdio.h>
#include <X11/Xlib.h>
#include "util.h"

//flags
#define MWM_HINTS_FUNCTIONS     (1<<0)
#define MWM_HINTS_DECORATIONS   (1<<1)
#define MWM_HINTS_INPUT_MODE    (1<<2)

//functions
#define MWM_FUNC_ALL            (1<<0)
#define MWM_FUNC_RESIZE         (1<<1)
#define MWM_FUNC_MOVE           (1<<2)
#define MWM_FUNC_MINIMIZE       (1<<3)
#define MWM_FUNC_MAXIMIZE       (1<<4)
#define MWM_FUNC_CLOSE          (1<<5)

//decorations
#define MWM_DECOR_ALL           (1<<0)
#define MWM_DECOR_BORDER        (1<<1)
#define MWM_DECOR_RESIZEH       (1<<2)
#define MWM_DECOR_TITLE         (1<<3)
#define MWM_DECOR_MENU          (1<<4)
#define MWM_DECOR_MINIMIZE      (1<<5)
#define MWM_DECOR_MAXIMIZE      (1<<6)

int main(int argc,char **argv)
{
	Display *disp;
	Window win;
	XEvent ev;
	long val[3];
	Atom atom;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	win = create_test_window2(disp, 200, 200, 0, ButtonPress);

	//_MOTIF_WM_HINTS

	val[0] = MWM_HINTS_FUNCTIONS | MWM_HINTS_DECORATIONS;
	val[1] = MWM_FUNC_MOVE | MWM_FUNC_CLOSE;
	val[2] = MWM_DECOR_BORDER | MWM_DECOR_TITLE;

	atom = GET_ATOM("_MOTIF_WM_HINTS");

	XChangeProperty(disp, win, atom, atom, 32, PropModeReplace,
		(unsigned char *)val, 3);

	//イベント

	XMapWindow(disp, win);

	while(1)
	{
		XNextEvent(disp, &ev);

		if(event_quit(&ev)) break;

		if(ev.type == ButtonPress) break;
	}

	XCloseDisplay(disp);

	return 0;
}
