/* XFIXES 拡張機能で、セレクション所有者の変更時のイベントを取得
 *
 * -lXfixes
 *
 * 閉じるボタンで終了 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/extensions/Xfixes.h>
#include "util.h"

int main(int argc,char **argv)
{
	Display *disp;
	Window win;
	XEvent ev;
	int event_base,error_base;
	XFixesSelectionNotifyEvent *pev;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	if(!XFixesQueryExtension(disp, &event_base, &error_base))
	{
		printf("unsupported XFIXES\n");
		XCloseDisplay(disp);
		return 1;
	}

	win = create_test_window2(disp, 200, 200, 0, ButtonPress);

	//イベント選択

	XFixesSelectSelectionInput(disp, win,
		GET_ATOM("CLIPBOARD"),
		XFixesSetSelectionOwnerNotifyMask
			| XFixesSelectionWindowDestroyNotifyMask
			| XFixesSelectionClientCloseNotifyMask);

	//イベント

	XMapWindow(disp, win);

	while(1)
	{
		XNextEvent(disp, &ev);

		if(event_quit(&ev)) break;

		if(ev.type == event_base + XFixesSelectionNotify)
		{
			pev = (XFixesSelectionNotifyEvent *)&ev;
			
			printf("[XFixesSelectionNotify] subtype(%d) owner(0x%lx) "
				"timestamp(0x%lx) selection_timestamp(0x%lx)\n",
				pev->subtype, pev->owner, pev->timestamp,
				pev->selection_timestamp);
		}
	}

	XCloseDisplay(disp);

	return 0;
}
