/* SHAPE 拡張機能
 *
 * -lXext
 *
 * 閉じるボタン、またはボタン押しで終了。 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/extensions/shape.h>
#include "util.h"

#define WIDTH  101
#define HEIGHT 101

static void _set_shape(Display *disp,Window win)
{
	Region r;
	XPoint pt[5];

	pt[0].x = WIDTH / 2, pt[0].y = 0;
	pt[1].x = WIDTH - 1, pt[1].y = HEIGHT / 2;
	pt[2].x = WIDTH / 2, pt[2].y = HEIGHT - 1;
	pt[3].x = 0, pt[3].y = HEIGHT / 2;
	pt[4] = pt[0];

	r = XPolygonRegion(pt, 5, EvenOddRule);

	XShapeCombineRegion(disp, win, ShapeBounding, 0, 0, r, ShapeSet);

	XDestroyRegion(r);
}

int main(int argc,char **argv)
{
	Display *disp;
	Window win;
	XEvent ev;
	int major,minor;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	if(!XShapeQueryVersion(disp, &major, &minor))
		printf("unsupported SHAPE\n");
	else
		printf("SHAPE ver %d.%d\n", major, minor);

	//

	win = create_test_window2(disp, WIDTH, HEIGHT, 0, ButtonPress);

	_set_shape(disp, win);

	//イベント

	XMapWindow(disp, win);

	while(1)
	{
		XNextEvent(disp, &ev);

		if(event_quit(&ev)) break;

		if(ev.type == ButtonPress) break;
	}

	XCloseDisplay(disp);

	return 0;
}
