/* XInput2 : デバイス情報
 *
 * -lXi */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/extensions/XInput2.h>

const char *g_use[] = {
 "MasterPointer", "MasterKeyboard", "SlavePointer", "SlaveKeyboard", "FloatingSlave"
};

int main(int argc,char **argv)
{
	Display *disp;
	XIDeviceInfo *info,*pi;
	int major,minor,dnum,i;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	//version

	major = 2, minor = 4;

	if(XIQueryVersion(disp, &major, &minor) != Success)
	{
		printf("unsupported XI2\n");
		XCloseDisplay(disp);
		return 1;
	}

	printf("ver %d.%d\n\n", major, minor);

	//デバイス情報

	info = XIQueryDevice(disp, XIAllDevices, &dnum);

	for(i = 0; i < dnum; i++)
	{
		pi = info + i;

		printf("-- [%s] --\ndeviceid(%d) use(%s) attachment(%d) enabled(%d) num_classes(%d)\n",
			pi->name, pi->deviceid, g_use[pi->use - 1], pi->attachment,
			pi->enabled, pi->num_classes);
	}

	XIFreeDeviceInfo(info);

	//

	XCloseDisplay(disp);

	return 0;
}
