/* XKB: 名前 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/XKBlib.h>
#include "util.h"

static void _put_names(XkbNamesPtr p)
{
	int i;

	put_atom_name_line("keycodes: ", p->keycodes);
	put_atom_name_line("geometry: ", p->geometry);
	put_atom_name_line("symbols: ", p->symbols);
	put_atom_name_line("types: ", p->types);
	put_atom_name_line("compat: ", p->compat);
	put_atom_name_line("phys_symbols: ", p->phys_symbols);

	//vmods

	printf("--- vmods ---\n");

	for(i = 0; i < XkbNumVirtualMods; i++)
	{
		if(p->vmods[i])
		{
			printf("[%d] ", i);
			put_atom_name_line(NULL, p->vmods[i]);
		}
	}

	//indicators

	printf("--- indicators ---\n");

	for(i = 0; i < XkbNumIndicators; i++)
	{
		if(p->indicators[i])
		{
			printf("[%d] ", i);
			put_atom_name_line(NULL, p->indicators[i]);
		}
	}

	//groups

	printf("--- groups ---\n");

	for(i = 0; i < XkbNumKbdGroups; i++)
	{
		if(p->groups[i])
		{
			printf("[%d] ", i);
			put_atom_name_line(NULL, p->groups[i]);
		}
	}

	//keys

	printf("--- keys ---\n");

	for(i = 0; i < p->num_keys; i++)
		printf("[%d] %.4s\n", i, p->keys[i].name);

	//key_aliases

	printf("--- key_aliases ---\n");

	for(i = 0; i < p->num_key_aliases; i++)
	{
		printf("[%d] real(%.4s) alias(%.4s)\n",
			i, p->key_aliases[i].real, p->key_aliases[i].alias);
	}

	//radio_groups

	printf("--- radio_groups ---\n");

	for(i = 0; i < p->num_rg; i++)
	{
		printf("[%d] ", i);
		put_atom_name_line(NULL, p->radio_groups[i]);
	}
}

int main(int argc,char **argv)
{
	Display *disp;
	XkbDescPtr desc;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	//XKB 初期化

	if(init_xkb(disp, NULL))
		return 1;

	//データ取得

	desc = XkbGetKeyboard(disp, XkbAllComponentsMask, XkbUseCoreKbd);

	_put_names(desc->names);

	XkbFreeKeyboard(desc, 0, True);

	XCloseDisplay(disp);

	return 0;
}
