/* XKB: 仮想修飾子 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/XKBlib.h>
#include "util.h"

static void _put_vmods(XkbDescPtr p)
{
	int i;

	printf("--- vmods ---\n");

	for(i = 0; i < XkbNumVirtualMods; i++)
	{
		if(p->names->vmods[i])
		{
			printf("[%d] \"", i);
			put_atom_name(p->names->vmods[i]);
			printf("\" 0x%02x\n", p->server->vmods[i]);
		}
	}
}

static void _put_vmodmap(XkbDescPtr p)
{
	int i;

	printf("--- vmodmap ---\n");

	for(i = p->min_key_code; i <= p->max_key_code; i++)
	{
		if(p->server->vmodmap[i])
		{
			printf("[%d] %.4s (0x%04x)\n",
				i, p->names->keys[i].name, p->server->vmodmap[i]);
		}
	}
}

int main(int argc,char **argv)
{
	Display *disp;
	XkbDescPtr desc;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	//XKB 初期化

	if(init_xkb(disp, NULL))
		return 1;

	//データ取得

	desc = XkbGetKeyboard(disp, XkbAllComponentsMask, XkbUseCoreKbd);

	printf("keycode: %d - %d\n",
		desc->min_key_code, desc->max_key_code);

	_put_vmods(desc);
	_put_vmodmap(desc);

	XkbFreeKeyboard(desc, 0, True);

	XCloseDisplay(disp);

	return 0;
}
