
#define GET_ATOM(str) XInternAtom(g_disp.disp, str, False)

/* ディスプレイ情報*/

typedef struct
{
	unsigned char r_shift, g_shift, b_shift,
		r_bits, g_bits, b_bits;
	int r_max, g_max, b_max,
		depth,
		def_screen_no,
		opcode; //拡張機能用

	Display *disp;
	Screen *screen;

	Window root;
	GC gc;
	Atom atoms[2];
}dispinfo;

extern dispinfo g_disp;

enum
{
	ATOM_WM_PROTOCOLS,
	ATOM_WM_DELETE_WINDOW
};


void set_display(Display *d);
void init_locale(void);
Window create_test_window(Display *disp,long event_mask);
Window create_test_window2(Display *disp,int width,int height,int bkgnd,long event_mask);
void set_window_protocols(Window win);
void eventloop_button_quit(Display *disp);
int event_quit(XEvent *ev);

unsigned int rgb_to_pixel(unsigned int col);
unsigned int rgb_to_pixel_sep(int r,int g,int b);
void put_state(unsigned int s);
void ximage_setbuf(XImage *img,unsigned char *buf,unsigned int pixcol);

XIMStyle get_xim_style_nothing(XIM im);
XIMStyle get_xim_style(XIM im,XIMStyle preedit);
void put_xic_text(XEvent *ev,XIC ic);

void *read_prop32(Window win,Atom prop,Atom prop_type,int *num_ret);
int read_prop32_array(Window win,Atom prop,Atom prop_type,void *buf,int num);
void *read_prop8(Window win,Atom prop,Atom *ret_type,int *ret_size);
void set_prop32_one(Window win,Atom prop,Atom prop_type,long val);
void set_prop32_array(Window win,Atom prop,Atom prop_type,void *buf,int num);
void put_atom_name(Atom atom);
void put_atom_name_line(const char *prefix,Atom atom);
void put_atoms_name(Atom *buf,int num);
void put_prop_atoms(Window win,Atom prop,const char *name);
void put_prop_num(Window win,Atom prop,Atom proptype,const char *name);

/* xkb */

int init_xkb(Display *disp,int *event_type);

/* xi2 */

int xi2_init(void);
void xi2_select_event(Window win,int deviceid,unsigned int mask);
void *xi2_get_event(XEvent *ev);

