/* ディスプレイの情報 */

#include <stdio.h>
#include <X11/Xlib.h>

int main(int argc,char **argv)
{
	Display *d;
	Screen *s;
	XPixmapFormatValues *pixf;
	int i,cnt,*narr;
	
	d = XOpenDisplay(NULL);
	if(!d) return 1;

	printf("ConnectionNumber: %d\n", ConnectionNumber(d));
	printf("DefaultRootWindow(XID): %lu\n", DefaultRootWindow(d));
	printf("DefaultScreen: %d\n", DefaultScreen(d));
	printf("DisplayString: '%s'\n", DisplayString(d));
	printf("LastKnownRequestProcessed: %lu\n", LastKnownRequestProcessed(d));
	printf("NextRequest: %lu\n", NextRequest(d));
	printf("ProtocolVersion: %d\n", ProtocolVersion(d));
	printf("ProtocolRevision: %d\n", ProtocolRevision(d));
	printf("QLength: %d\n", QLength(d));
	printf("ScreenCount: %d\n", ScreenCount(d));
	printf("ServerVendor: '%s'\n", ServerVendor(d));
	printf("VendorRelease: 0x%x\n", VendorRelease(d));

	//screen

	s = DefaultScreenOfDisplay(d);

	printf("\n[screen]\n");
	printf("BlackPixelOfScreen: 0x%lx\n", BlackPixelOfScreen(s));
	printf("WhitePixelOfScreen: 0x%lx\n", WhitePixelOfScreen(s));
	printf("CellsOfScreen: %d\n", CellsOfScreen(s));
	printf("DefaultColormapOfScreen(XID): %lu\n", DefaultColormapOfScreen(s));
	printf("DefaultDepthOfScreen: %d\n", DefaultDepthOfScreen(s));
	printf("DoesBackingStore: %d\n", DoesBackingStore(s));
	printf("DoesSaveUnders: %d\n", DoesSaveUnders(s));
	printf("EventMaskOfScreen: 0x%lx\n", EventMaskOfScreen(s));
	printf("WidthOfScreen: %d\n", WidthOfScreen(s));
	printf("HeightOfScreen: %d\n", HeightOfScreen(s));
	printf("WidthMMOfScreen: %d\n", WidthMMOfScreen(s));
	printf("HeightMMOfScreen: %d\n", HeightMMOfScreen(s));
	printf("MaxCmapsOfScreen: %d\n", MaxCmapsOfScreen(s));
	printf("MinCmapsOfScreen: %d\n", MinCmapsOfScreen(s));
	printf("PlanesOfScreen: %d\n", PlanesOfScreen(s));
	printf("RootWindowOfScreen(XID): %lu\n", RootWindowOfScreen(s));

	//使用可能な深さ

	narr = XListDepths(d, DefaultScreen(d), &cnt);
	if(narr)
	{
		printf("\n[depths]\n");
		
		for(i = 0; i < cnt; i++)
			printf("%d,", narr[i]);

		printf("\n");
		
		XFree(narr);
	}

	//イメージフォーマット

	printf("\n[image]\n");

	printf("ImageByteOrder: %d\n", ImageByteOrder(d));
	printf("BitmapUnit: %d\n", BitmapUnit(d));
	printf("BitmapBitOrder: %d\n", BitmapBitOrder(d));
	printf("BitmapPad: %d\n", BitmapPad(d));

	pixf = XListPixmapFormats(d, &cnt);
	if(pixf)
	{
		printf("\n[ListPixmapFormats]\n");
		
		for(i = 0; i < cnt; i++)
		{
			printf("depth: %d, bits_per_pixel:%d, scanline_pad:%d\n",
				pixf[i].depth, pixf[i].bits_per_pixel, pixf[i].scanline_pad);
		}

		printf("\n");
	
		XFree(pixf);
	}

	//閉じる

	XCloseDisplay(d);

	return 0;
}
