/* スクリーンでサポートされているビジュアルのリスト */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

const char *class_names[] = {
 "StaticGray", "GrayScale", "StaticColor", "PseudoColor", "TrueColor", "DirectColor"
};

int main(int argc,char **argv)
{
	Display *d;
	XVisualInfo *vi,vitmp;
	int i,cnt;
	
	d = XOpenDisplay(NULL);
	if(!d) return 1;

	vitmp.screen = DefaultScreen(d);

	vi = XGetVisualInfo(d, VisualScreenMask, &vitmp, &cnt);
	if(vi)
	{
		for(i = 0; i < cnt; i++)
		{
			printf("----[%d]---\n", i);
			printf("visualid: %lu\n", vi[i].visualid);
			printf("depth: %d\n", vi[i].depth);
			printf("class: (%d) %s\n", vi[i].class, class_names[vi[i].class]);
			printf("red_mask: 0x%lx\n", vi[i].red_mask);
			printf("green_mask: 0x%lx\n", vi[i].green_mask);
			printf("blue_mask: 0x%lx\n", vi[i].blue_mask);
			printf("colormap_size: %d\n", vi[i].colormap_size);
			printf("bits_per_rgb: %d\n", vi[i].bits_per_rgb);
		}

		XFree(vi);
	}

	XCloseDisplay(d);

	return 0;
}
