/* GLX の情報を表示
 *
 * -lGLX -lX11 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <GL/glx.h>

int main(int argc,char **argv)
{
	Display *disp;
	Visual *visual;
	GLXFBConfig *pcf,cf;
	int major,minor,i,num,cnt,val,r,g,b,a;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	visual = DefaultVisual(disp, DefaultScreen(disp));
	
	printf("default visual id: %lu\n", XVisualIDFromVisual(visual));

	//GLX のバージョン取得
	
	if(!glXQueryVersion(disp, &major, &minor)
		|| (major == 1 && minor < 4))
	{
		printf("unsupported GLX ver 1.4\n");
		XCloseDisplay(disp);
		return 1;
	}

	//指定スクリーンで使用可能なすべての GLXFBConfig

	pcf = glXGetFBConfigs(disp, DefaultScreen(disp), &num);
	if(pcf)
	{
		cnt = 0;
		
		for(i = 0; i < num; i++)
		{
			cf = pcf[i];

			glXGetFBConfigAttrib(disp, cf, GLX_VISUAL_ID, &val);

			if(val == 0) continue;

			printf("--- [%d] ---\n", cnt++);
			printf("visual_id: %d\n", val);

			glXGetFBConfigAttrib(disp, cf, GLX_BUFFER_SIZE, &val);
			glXGetFBConfigAttrib(disp, cf, GLX_RED_SIZE, &r);
			glXGetFBConfigAttrib(disp, cf, GLX_GREEN_SIZE, &g);
			glXGetFBConfigAttrib(disp, cf, GLX_BLUE_SIZE, &b);
			glXGetFBConfigAttrib(disp, cf, GLX_ALPHA_SIZE, &a);

			printf("buffer: %dbit (R:%d, G:%d, B:%d, A:%d)\n", val, r, g, b, a);

			glXGetFBConfigAttrib(disp, cf, GLX_DEPTH_SIZE, &val);
			printf("zbuf: %dbit\n", val);

			glXGetFBConfigAttrib(disp, cf, GLX_STENCIL_SIZE, &val);
			printf("stencil: %dbit\n", val);
		}

		XFree(pcf);
	}

	XCloseDisplay(disp);

	return 0;
}
