/* 指定RGB値を背景色に
 *
 * 左クリックで、背景色が変わっていく。
 * それ以外のボタンを押すと、終了。 */

#include <X11/Xlib.h>
#include "util.h"

unsigned int g_colors[] = {0,0xff0000, 0x00ff00, 0x0000ff, 0xffffff, 0xffff00, 0xff00ff, 0x00ffff};
int g_current = 0;

int main(int argc,char **argv)
{
	Display *disp;
	XSetWindowAttributes attr;
	Window win;
	XEvent ev;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	//ウィンドウ作成

	attr.background_pixel = rgb_to_pixel(g_colors[g_current]);
	attr.event_mask = ButtonPressMask;

	win = XCreateWindow(disp, DefaultRootWindow(disp),
		0, 0, 200, 200, 0,
		CopyFromParent, CopyFromParent, CopyFromParent,
		CWBackPixel | CWEventMask, &attr);

	XMapWindow(disp, win);

	//イベント

	while(1)
	{
		XNextEvent(disp, &ev);

		switch(ev.type)
		{
			case ButtonPress:
				if(ev.xbutton.button == Button1)
				{
					g_current++;
					if(g_current == sizeof(g_colors) / sizeof(int)) g_current = 0;
					
					XSetWindowBackground(disp, win, rgb_to_pixel(g_colors[g_current]));
					XClearWindow(disp, win);
				}
				else
					goto END;
		}
	}

	//

END:
	XDestroyWindow(disp, win);

	XCloseDisplay(disp);

	return 0;
}

