/* ポインタイベント
 *
 * Enter キー押しで終了 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include "util.h"

int main(int argc,char **argv)
{
	Display *disp;
	XSetWindowAttributes attr;
	Window win;
	XEvent ev;
	KeySym key;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	//ウィンドウ作成

	attr.background_pixel = 0;
	attr.event_mask = ButtonPressMask | ButtonReleaseMask
		| PointerMotionMask | ButtonMotionMask
		| EnterWindowMask | LeaveWindowMask | KeyPressMask
		//| PointerMotionHintMask
		;

	win = XCreateWindow(disp, DefaultRootWindow(disp),
		0, 0, 200, 200, 0,
		CopyFromParent, CopyFromParent, CopyFromParent,
		CWBackPixel | CWEventMask, &attr);

	XMapWindow(disp, win);

	//イベント

	while(1)
	{
		XNextEvent(disp, &ev);

		switch(ev.type)
		{
			case ButtonPress:
			case ButtonRelease:
				printf("* [%s] serial(%lu) time(%lu) x(%d) y(%d) x_root(%d) y_root(%d)\n",
					(ev.type == ButtonPress)? "Press": "Release",
					ev.xbutton.serial, ev.xbutton.time, ev.xbutton.x, ev.xbutton.y,
					ev.xbutton.x_root, ev.xbutton.y_root);

				put_state(ev.xbutton.state);
				
				printf("  button(%u)\n", ev.xbutton.button);
				fflush(stdout);
				break;
			case MotionNotify:
				printf("- [Motion] serial(%lu) time(%lu) x(%d) y(%d) x_root(%d) y_root(%d)\n",
					ev.xmotion.serial, ev.xmotion.time, ev.xmotion.x, ev.xmotion.y,
					ev.xmotion.x_root, ev.xmotion.y_root);

				put_state(ev.xmotion.state);

				printf("  is_hint(%d)\n", ev.xmotion.is_hint);
				fflush(stdout);
				break;
			case EnterNotify:
			case LeaveNotify:
				printf("$ [%s] serial(%lu) time(%lu) x(%d) y(%d) x_root(%d) y_root(%d)\n",
					(ev.type == EnterNotify)? "Enter": "Leave",
					ev.xcrossing.serial, ev.xcrossing.time, ev.xcrossing.x, ev.xcrossing.y,
					ev.xcrossing.x_root, ev.xcrossing.y_root);

				printf("  mode(%d) detail(%d) focus(%d)\n",
					ev.xcrossing.mode, ev.xcrossing.detail, ev.xcrossing.focus);

				put_state(ev.xcrossing.state);
								
				fflush(stdout);
				break;

			case KeyPress:
				key = XLookupKeysym((XKeyEvent *)&ev, 0);
				if(key == XK_Return || key == XK_KP_Enter) goto END;
				break;
		}
	}

END:
	XCloseDisplay(disp);

	return 0;
}

