/* X エラー */

#include <stdio.h>
#include <X11/Xlib.h>

static int _xerr_handle(Display *display,XErrorEvent *ev)
{
	char m[256],no[16];

	printf("--- X error ---\n"
		"type(%d) serial(%lu) error_code(%d)\n"
		"request_code(%d) minor_code(%d) resourceid(%lu)\n\n",
		ev->type, ev->serial, ev->error_code,
		ev->request_code, ev->minor_code, ev->resourceid);

	XGetErrorText(display, ev->error_code, m, 256);
	printf("[Error] %s\n", m);

	snprintf(no, 16, "%d", ev->request_code);
	XGetErrorDatabaseText(display, "XRequest", no, "default error", m, 256);
	printf("[Request] %s\n", m);

	return 1;
}

int main(int argc,char **argv)
{
	Display *disp;

	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	XSetErrorHandler(_xerr_handle);

	XDestroyWindow(disp, 0);

	XCloseDisplay(disp);

	return 0;
}
