/* ポインタのパッシブグラブ
 *
 * Enter キー押しで終了 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include "util.h"

int main(int argc,char **argv)
{
	Display *disp;
	XSetWindowAttributes attr;
	Window win;
	XEvent ev;
	KeySym key;
	Cursor cursor;
	int fmap = 0;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	//ウィンドウ作成

	attr.background_pixel = 0;
	attr.event_mask = ButtonPressMask | ButtonReleaseMask
		| PointerMotionMask | ButtonMotionMask | KeyPressMask
		| StructureNotifyMask;

	win = XCreateWindow(disp, DefaultRootWindow(disp),
		0, 0, 200, 200, 0,
		CopyFromParent, CopyFromParent, CopyFromParent,
		CWBackPixel | CWEventMask, &attr);

	//グラブ中のカーソル

	cursor = XCreateFontCursor(disp, XC_hand1);

	//右ボタンをグラブ

	XGrabButton(disp, Button3, AnyModifier, win, False,
		ButtonPressMask | ButtonReleaseMask | PointerMotionMask | ButtonMotionMask,
		GrabModeAsync, GrabModeAsync, None, cursor);

	//イベント

	XMapWindow(disp, win);

	while(1)
	{
		XNextEvent(disp, &ev);

		switch(ev.type)
		{
			case ButtonPress:
			case ButtonRelease:
				printf("* [%s] x(%d) y(%d) button(%d)\n",
					(ev.type == ButtonPress)? "Press": "Release",
					ev.xbutton.x, ev.xbutton.y, ev.xbutton.button);
				fflush(stdout);
				break;
			case MotionNotify:
				printf("- [Motion] x(%d) y(%d)\n", ev.xmotion.x, ev.xmotion.y);
				fflush(stdout);
				break;

			case MapNotify:
				if(fmap == 0)
				{
					printf("# grab Button1\n");

					//左ボタンをグラブ

					XGrabButton(disp, Button1, AnyModifier, win, False,
						ButtonPressMask | ButtonReleaseMask | PointerMotionMask | ButtonMotionMask,
						GrabModeAsync, GrabModeAsync, None, cursor);

					fmap = 1;
				}
				break;

			case KeyPress:
				key = XLookupKeysym((XKeyEvent *)&ev, 0);
				if(key == XK_Return || key == XK_KP_Enter)
					goto END;
				break;
		}
	}

END:
	XCloseDisplay(disp);

	return 0;
}

