/* キーマッピング表示 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>

int main(int argc,char **argv)
{
	Display *disp;
	KeySym *buf,*ptr,ksym;
	XModifierKeymap *mmap;
	KeyCode *kptr;
	char *name;
	int i,j,cnt,min,max,num;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	XDisplayKeycodes(disp, &min, &max);

	printf("min: %d, max: %d\n", min, max);

	//キーマップ

	printf("\n--- key map ---\n");

	cnt = max - min + 1;

	buf = ptr = XGetKeyboardMapping(disp, min, cnt, &num);

	for(i = 0; i < cnt; i++)
	{
		printf("[%d]", min + i);
		
		for(j = 0; j < num; j++, ptr++)
		{
			if(*ptr == NoSymbol)
				printf(" -");
			else if(*ptr == XK_VoidSymbol)
				printf(" <void>");
			else
			{
				name = XKeysymToString(*ptr);

				printf(" %s", (name)? name: "<?>");
			}
		}

		printf("\n");
	}

	//修飾子マップ

	printf("\n--- modifier map ---\n");

	mmap = XGetModifierMapping(disp);

	kptr = mmap->modifiermap;

	for(i = 0; i < 8; i++)
	{
		printf("[%d]", i);
		
		for(j = 0; j < mmap->max_keypermod; j++, kptr++)
		{
			printf(" %d", *kptr);

			if(*kptr)
			{
				ptr = buf + (*kptr - min) * num;
				ksym = (ptr[0] == NoSymbol)? ptr[1]: ptr[0];
				
				if(ksym != NoSymbol)
				{
					name = XKeysymToString(ksym);
					if(name) printf("(%s)", name);
				}
			}
		}

		printf("\n");
	}

	//

	XFree(buf);
	XFreeModifiermap(mmap);

	XCloseDisplay(disp);

	return 0;
}

