/* キーイベント2
 *
 * ウィンドウ内でボタンが押されたら終了 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "util.h"

int main(int argc,char **argv)
{
	Display *disp;
	XSetWindowAttributes attr;
	Window win;
	XEvent ev;
	KeySym ksym;
	char m[16],*name;
	int len;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	//ウィンドウ作成

	attr.background_pixel = 0;
	attr.event_mask = ButtonPressMask | KeyPressMask | KeyReleaseMask;

	win = XCreateWindow(disp, DefaultRootWindow(disp),
		0, 0, 200, 200, 0,
		CopyFromParent, CopyFromParent, CopyFromParent,
		CWBackPixel | CWEventMask, &attr);

	XMapWindow(disp, win);

	//イベント

	while(1)
	{
		XNextEvent(disp, &ev);

		switch(ev.type)
		{
			case KeyPress:
			case KeyRelease:
				len = XLookupString((XKeyEvent *)&ev, m, 15, &ksym, 0);
				m[len] = 0;

				name = XKeysymToString(ksym);
				
				printf("[%s] keycode(%u) keysym(%lu)[%s] time(%lu)",
					(ev.type == KeyPress)? "Press": "Release",
					ev.xkey.keycode, ksym,
					(name)? name: "-", ev.xkey.time);

				if(len)
				{
					if(m[0] >= 0x20 && m[0] < 0x7f)
						printf(" '%s'", m);
					else
						printf(" <%d>", m[0]);
				}

				printf("\n");
				put_state(ev.xkey.state);
				fflush(stdout);
				break;
			case ButtonPress:
				goto END;
		}
	}

END:
	XCloseDisplay(disp);

	return 0;
}

