/* ウィンドウの状態変化イベント
 *
 * ウィンドウ内でボタンが押されたら終了 */

#include <stdio.h>
#include <X11/Xlib.h>

int main(int argc,char **argv)
{
	Display *disp;
	XSetWindowAttributes attr;
	Window win;
	XEvent ev;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	//ウィンドウ作成

	attr.background_pixel = 0;
	attr.event_mask = ButtonPressMask | StructureNotifyMask
	 | VisibilityChangeMask;

	win = XCreateWindow(disp, DefaultRootWindow(disp),
		0, 0, 200, 200, 0,
		CopyFromParent, CopyFromParent, CopyFromParent,
		CWBackPixel | CWEventMask, &attr);

	XMapWindow(disp, win);

	//イベント

	while(1)
	{
		XNextEvent(disp, &ev);

		switch(ev.type)
		{
			case ConfigureNotify:
				printf("[Configure] event(0x%lx) window(0x%lx) send_event(%d) x(%d) y(%d)\n"
					"  width(%d) height(%d) border_width(%d) above(0x%lx)\n",
					ev.xconfigure.event, ev.xconfigure.window, ev.xconfigure.send_event,
					ev.xconfigure.x, ev.xconfigure.y,
					ev.xconfigure.width, ev.xconfigure.height,
					ev.xconfigure.border_width, ev.xconfigure.above);
				break;
			case MapNotify:
				printf("[Map]\n");
				break;
			case UnmapNotify:
				printf("[Unmap]\n");
				break;
			case VisibilityNotify:
				printf("[Visibility] state(%d)\n", ev.xvisibility.state);
				break;
			case ReparentNotify:
				printf("[Reparent] parent(0x%lx) x(%d) y(%d)\n",
					ev.xreparent.parent, ev.xreparent.x, ev.xreparent.y);
				break;
			case ButtonPress:
				goto END;
		}
	}

END:
	XCloseDisplay(disp);

	return 0;
}

