/* グラフィック
 *
 * ウィンドウ内でボタンが押されたら終了 */

#include <X11/Xlib.h>
#include "util.h"

int main(int argc,char **argv)
{
	Display *disp;
	XSetWindowAttributes attr;
	Window win;
	XEvent ev;
	GC gc;
	int width,height;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	set_display(disp);

	//ウィンドウ作成

	width = 200, height = 200;

	attr.background_pixel = 0;
	attr.event_mask = ButtonPressMask | ExposureMask | StructureNotifyMask;

	win = XCreateWindow(disp, DefaultRootWindow(disp),
		0, 0, width, height, 0,
		CopyFromParent, CopyFromParent, CopyFromParent,
		CWBackPixel | CWEventMask, &attr);

	//

	gc = XCreateGC(disp, win, 0, NULL);

	XMapWindow(disp, win);

	//イベント

	while(1)
	{
		XNextEvent(disp, &ev);

		switch(ev.type)
		{
			case Expose:
				XClearWindow(disp, win);

				XSetForeground(disp, gc, rgb_to_pixel(0x0000ff));
				XFillRectangle(disp, win, gc, 10, 10, width - 20, height - 20);

				XSetForeground(disp, gc, rgb_to_pixel(0xff0000));
				XDrawLine(disp, win, gc, 0, 0, width - 1, height - 1);
				XDrawLine(disp, win, gc, width - 1, 0, 0, height - 1);
				break;
			case ConfigureNotify:
				width = ev.xconfigure.width;
				height = ev.xconfigure.height;
				if(width < 30) width = 30;
				if(height < 30) height = 30;
				break;
			case ButtonPress:
				goto END;
		}
	}

END:
	XCloseDisplay(disp);

	return 0;
}

