/* 入力メソッド - XIM */

#include <stdio.h>
#include <X11/Xlib.h>
#include "util.h"

static void _put_style(XIMStyle n)
{
	if(n & XIMPreeditArea) printf(" PreeditArea");
	if(n & XIMPreeditCallbacks) printf(" PreeditCallbacks");
	if(n & XIMPreeditPosition) printf(" PreeditPosition");
	if(n & XIMPreeditNothing) printf(" PreeditNothing");
	if(n & XIMPreeditNone) printf(" PreeditNone");

	if(n & XIMStatusArea) printf(" StatusArea");
	if(n & XIMStatusCallbacks) printf(" StatusCallbacks");
	if(n & XIMStatusNothing) printf(" StatusNothing");
	if(n & XIMStatusNone) printf(" StatusNone");

	printf("\n");
}

int main(int argc,char **argv)
{
	Display *disp;
	XIM im;
	XIMStyles *styles = NULL;
	XIMValuesList *imval = NULL, *icval = NULL;
	int i;
	
	disp = XOpenDisplay(NULL);
	if(!disp) return 1;

	init_locale();

	//IM 開く

	im = XOpenIM(disp, NULL, NULL, NULL);
	if(!im)
	{
		printf("failed XOpenIM\n");
		XCloseDisplay(disp);
		return 0;
	}

	//IM プロパティの取得

	XGetIMValues(im,
		XNQueryInputStyle, &styles,
		XNQueryIMValuesList, &imval,
		XNQueryICValuesList, &icval,
		(void *)0);

	//入力スタイル

	if(styles)
	{
		printf("-- input style --\n");
		
		for(i = 0; i < styles->count_styles; i++)
		{
			printf("[%d]", i);

			_put_style(styles->supported_styles[i]);
		}

		XFree(styles);
	}

	//IM 値の名前

	if(imval)
	{
		printf("\n-- IM values --\n");

		for(i = 0; i < imval->count_values; i++)
			printf("[%d] %s\n", i, imval->supported_values[i]);

		XFree(imval);
	}

	//IC 値の名前

	if(icval)
	{
		printf("\n-- IC values --\n");

		for(i = 0; i < icval->count_values; i++)
			printf("[%d] %s\n", i, icval->supported_values[i]);

		XFree(icval);
	}

	//

	XCloseIM(im);

	XCloseDisplay(disp);

	return 0;
}
